﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourQLInterpreter.Exceptions
{
    public class ParsingException : FourqlException
    {
        private ICollection<FourqlParser.Parsers.ParserDispatcher.Error<Antlr4.Runtime.IToken>> _errors;
 



        public ParsingException(ICollection<FourqlParser.Parsers.ParserDispatcher.Error<Antlr4.Runtime.IToken>> collection) : base(PrintErrors(collection))
        {
            this._errors = collection;
        }

        public ParsingException(string message, Exception e) : base(message, e)
        {
        }


        private static string PrintErrors(ICollection<FourqlParser.Parsers.ParserDispatcher.Error<Antlr4.Runtime.IToken>> errors)
        {
            StringBuilder sb = new StringBuilder();
            foreach (var err in errors)
            {
                sb.AppendLine(err.Message);
            }
            return sb.ToString();
        }
    }
}
