﻿using System;
using FourQLInterpreter.WSM;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace _4QLInterpreterTest
{
    [TestClass]
    public class HierarchyTest : BaseModuleTests
    {
        [TestMethod]
        public void TestHierarchyConstruction()
        {
            var modules = LoadModules("hierarchy.4ql");
            var hierarchy = new ModuleHierarchy(modules.Values);
            var result = (hierarchy.ConstructHierarchy());
            Assert.AreEqual(4, result.Count);
            Assert.AreEqual(2, result[0].Count);
            Assert.AreEqual(2, result[1].Count);
            Assert.AreEqual(1, result[2].Count);
            Assert.AreEqual(1, result[3].Count);

        }

        [TestMethod]
        public void TestSubgraphConstruction()
        {
            var modules = LoadModules("hierarchy.4ql");
            var hierarchy = new ModuleHierarchy(modules.Values);
            hierarchy.ConstructHierarchy();
            var result = hierarchy.GetModuleSubgraph("m2");
            Assert.AreEqual(2, result.Count);
            Assert.AreEqual(1, result[3].Count);
            Assert.AreEqual(1, result[2].Count);
        }
    }
}
