﻿using System;
using System.Linq;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using FourqlParser.Parsers;
using FourQLInterpreter.Reasoning;
using FourqlParser.Structures;

namespace _4QLInterpreterTest
{
    [TestClass]
    public class UnitTest1 : BaseModuleTests
    {
        [TestMethod]
        [ExpectedExceptionWithMessageAttribute(typeof(System.Exception), "Relation cannot have the same name as domain! Relation 'dom' in module 'sampleM'.")]
        public void SampleTest1()
        {
           
            var errors = new ParserDispatcher.Errors();
            var progContext = ParserDispatcher.parseProgram(GetTestContent("sample.4ql"), errors, null);
            Console.WriteLine(errors.ParserErrors.Count);
            Assert.IsTrue(errors.ParserErrors.Count == 0);
            var prog = ParserDispatcher.toProgram(progContext);
            ParserDispatcher.checkProgram(prog);
            IDictionary<string, ModuleDataWrapper> modules = new Dictionary<string, ModuleDataWrapper>();
            foreach (var module in prog.Modules)
            {
                ModuleDataWrapper wrapper = new ModuleDataWrapper(module);
                wrapper.Initialize();
                modules[module.Name] = wrapper;
            }
            Evaluator evaluator = new Evaluator(modules);
            foreach (var rule in modules["sampleM"].Module.Rules)
            {
                var res = evaluator.Evaluate(rule.Body, modules["sampleM"].Module);
                Console.WriteLine(res.ToString());
            }
        }

        [TestMethod]
        public void SampleTest2()
        {

            var errors = new ParserDispatcher.Errors();
            var progContext = ParserDispatcher.parseProgram(GetTestContent("quantifiers.4ql"), errors, null);
            Console.WriteLine(errors.ParserErrors.Count);
            Assert.IsTrue(errors.ParserErrors.Count == 0);
            var prog = ParserDispatcher.toProgram(progContext);
            ParserDispatcher.checkProgram(prog);
            IDictionary<string, ModuleDataWrapper> modules = new Dictionary<string, ModuleDataWrapper>();
            foreach (var module in prog.Modules)
            {
                ModuleDataWrapper wrapper = new ModuleDataWrapper(module);
                wrapper.Initialize();
                modules[module.Name] = wrapper;
            }
            Evaluator evaluator = new Evaluator(modules);
            foreach (var rule in modules["main"].Module.Rules)
            {
                var res = evaluator.Evaluate(rule.Body, modules["main"].Module);
                Console.WriteLine(res.ToString());
            }
        }

       

    }
}
