﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace FourqlModeler.Commands
{
    public class AboutCommand : ICommand
    {
        #region ICommand Members

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            if (MessageBox.Show(
                "This is an educational application developed as a Master's degree project that aims to help with understanding the concept and language better.\n\n@Author: Lucas Makar (lm291701@students.mimuw.edu.pl)\n@Author: Maria Rekowska (mr292361@students.mimuw.edu.pl) \n\n@Details: For details go to www.4ql.org\n\nWould you like to visit the webpage?",
                "About",
                MessageBoxButton.YesNo, MessageBoxImage.Information) == MessageBoxResult.Yes)
            {
                System.Diagnostics.Process.Start("http://www.4ql.org");
            }
        }

        #endregion
    }
}
