﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using FourqlModeler.Utility;
using FourqlModeler.ViewModels;
using Parago.Windows;

namespace FourqlModeler.Commands
{
    class BuildAllModulesCommand : ICommand
    {
        private ModuleStorageViewModel ModuleStorageViewModel { get; set; }

        public BuildAllModulesCommand(ModuleStorageViewModel moduleStorageViewModel)
        {
            ModuleStorageViewModel = moduleStorageViewModel;
        }

        #region ICommand Members

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            ModuleStorageViewModel.BuildModulesCommand.Execute(ModuleStorageViewModel.Modules);
        }

        #endregion
    }
}
