﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using FourqlModeler.Calculcations;
using FourqlModeler.Communication;
using FourqlModeler.Communication.Import;
using FourqlModeler.ViewModels;
using FourqlModeler.Views;
using FourqlModeler.Views.ViewInterfaces;
using FourqlParser.Parsers;
using Parago.Windows;

namespace FourqlModeler.Commands.Console
{
    public class ClearConsoleCommand : ICommand
    {
        private IConsoleView Console;

        public ClearConsoleCommand(IConsoleView console)
        {
            Console = console;
        }

        #region ICommand Members

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public void Execute(object parameter)
        {
            Console.Clear();
        }
        
        #endregion
    }
}
