﻿using System;
using System.Linq;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using FourqlModeler.Views.ValueConverters;

namespace FourqlModeler.Commands.ErrorGrouping
{
    class ApplyGroupingByIdAndDescCommand : ICommand
    {
        #region ICommand Members

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            var grid = parameter as DataGrid;
            if (grid != null)
            {
                foreach (var column in grid.Columns.Where(col => col.Header.Equals("Description")).ToList())
                {
                    grid.Columns.Remove(column);
                }

                var collectionView = CollectionViewSource.GetDefaultView(grid.ItemsSource);
                if (collectionView != null && collectionView.CanGroup)
                {
                    collectionView.GroupDescriptions.Clear();
                    collectionView.GroupDescriptions.Add(new PropertyGroupDescription("", new GroupByIdAndDescriptionConverter()));
                }
            }
        }

        #endregion
    }
}
