﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;

namespace FourqlModeler.Commands.ErrorGrouping
{
    class RemoveGroupingCommand : ICommand
    {
        #region ICommand Members

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            var grid = parameter as DataGrid;
            if (grid != null)
            {
                var collectionView = CollectionViewSource.GetDefaultView(grid.ItemsSource);
                if (collectionView != null)
                {
                    collectionView.GroupDescriptions.Clear();
                }
                if (grid.Columns.Where(col => col.Header.Equals("Description")).Count() == 0)
                {
                    grid.Columns.Add(new DataGridTextColumn() { Header = "Description", Width = new DataGridLength(1.0, DataGridLengthUnitType.Star), Binding = new Binding("Description") });
                }
            }
        }

        #endregion
    }
}
