﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using FourqlModeler.Calculcations;
using FourqlModeler.Communication;
using FourqlModeler.Communication.Import;
using FourqlModeler.ViewModels;
using FourqlModeler.Views;
using FourqlParser.Parsers;

namespace FourqlModeler.Commands.Result
{
    class HideShowUnknownCommand : ICommand
    {
        private bool FilterUnknown { get; set; }
        #region ICommand Members

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public void Execute(object parameter)
        {
            var source = parameter as CollectionViewSource;
            if (source != null)
            {
                FilterUnknown = !FilterUnknown;
                if (FilterUnknown)
                {
                    source.Filter -= NotFilter;
                    source.Filter += Filter;    
                }
                else
                {
                    source.Filter -= Filter;
                    source.Filter += NotFilter;
                }
            }
        }
        
        #endregion

        private void Filter(object sender,  FilterEventArgs args)
        {
            var row = args.Item as Row;
            if (row != null)
            {
                args.Accepted = row.Value != FourqlParser.Structures.LogicValue.UNKNOWN;
            }
        }

        private void NotFilter(object sender, FilterEventArgs args)
        {
            args.Accepted = true;
        }
    }
}
