﻿using FourqlModeler.Dialogs;
using FourqlModeler.ViewModels;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using FourqlModeler.Utility;

namespace FourqlModeler.Commands
{
    public class SaveModuleCommand : ModuleViewModelCommand
    {
        public ModuleStorageViewModel ModuleStorageViewModel { get; set; }
        public bool ReparseAfterExecution { get; set; }

        public SaveModuleCommand(ModuleStorageViewModel moduleStorageViewModel, bool reparseAfterExecution = true)
        {
            ModuleStorageViewModel = moduleStorageViewModel;
            ReparseAfterExecution = reparseAfterExecution;
        }

        #region ModuleViewModelCommand Members

        protected override void ExecuteOn(ModuleViewModel moduleViewModel)
        {
            if (moduleViewModel.IsDirty)
            {
                FileDialogs.SaveFile(moduleViewModel.FileDir + moduleViewModel.FileName, moduleViewModel.Content);
                moduleViewModel.SavedContent = moduleViewModel.Content;
                moduleViewModel.IsDirty = false;

                if (ReparseAfterExecution)
                {
                    ModuleStorageViewModel.BuildModulesCommand.Execute(new List<ModuleViewModel>() { moduleViewModel });
                }
            }
        }

        #endregion
    }
}
