﻿using FourqlModeler.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace FourqlModeler.Commands
{
    public class UnloadAllModulesCommand : ICommand
    {
        private ModuleStorageViewModel ModuleStorageViewModel { get; set; }
        private ICommand UnloadModuleCommand { get; set; }

        public UnloadAllModulesCommand(ModuleStorageViewModel moduleStorageViewModel)
        {
            ModuleStorageViewModel = moduleStorageViewModel;
            UnloadModuleCommand = new UnloadModuleCommand(moduleStorageViewModel, false);
        }

        #region ICommand Members

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            var localModuleViewModels = ModuleStorageViewModel.Modules.Where(model => !model.IsInternalExternal).ToArray<ModuleViewModel>();
            foreach (var moduleViewModel in localModuleViewModels)
            {
                UnloadModuleCommand.Execute(moduleViewModel);
            }
            ModuleStorageViewModel.AllErrors.Clear();
            ModuleStorageViewModel.SelectedError = null;
        }

        #endregion
    }
}
