﻿using FourqlModeler.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using System.Windows.Data;

namespace FourqlModeler.Commands
{
    public class UnloadFolderModulesCommand : ICommand
    {
        private ModuleStorageViewModel ModuleStorageViewModel { get; set; }
        private ICommand UnloadModuleCommand { get; set; }

        public UnloadFolderModulesCommand(ModuleStorageViewModel moduleStorageViewModel)
        {
            ModuleStorageViewModel = moduleStorageViewModel;
            UnloadModuleCommand = new UnloadModuleCommand(moduleStorageViewModel, false);
        }

        #region ICommand Members

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            if (parameter == null)
            {
                return;
            }
            var fileDir = parameter.ToString();
            var localModuleViewModels = ModuleStorageViewModel.Modules.Where(model => !model.IsInternalExternal && model.FileDir.Equals(fileDir)).ToArray<ModuleViewModel>();
            foreach (var moduleViewModel in localModuleViewModels)
            {
                UnloadModuleCommand.Execute(moduleViewModel);
            }
            ModuleStorageViewModel.BuildModulesCommand.Execute(new List<ModuleViewModel>());
        }

        #endregion
    }
}
