﻿using FourqlModeler.Commands;
using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlModeler.Communication.Import
{
    class ImportExecutor
    {
        private readonly string TempFileName = "temp.4ql";

        public void execute(string fileName, IDictionary<string, Module> modules)
        {
            // Create a module reader.
            var reader = new ModuleReader();

            // Read the module file.
            reader.parseAndPush(fileName, modules);

            // Create a new combined module file.
            reader.createCombinedModuleFile(TempFileName, modules);

            // Clear modules from the interpreter first.
            ApplicationClient.Instance.ClearModules();
            //ApplicationClient.Instance.SendCommand(MessageFactory.clearMessage(new SuccessHandler()));

            // Ask the interpreter to load the temporary file.
            ApplicationClient.Instance.LoadModules(Path.GetFullPath(TempFileName));
            //ApplicationClient.Instance.SendCommand(MessageFactory.importMessage(Path.GetFullPath(TempFileName), new SuccessHandler()));
        }
    }
}
