﻿using GraphX;
using System;
using System.Collections.Generic;
using YAXLib;
using System.Windows.Media;

namespace FourqlModeler.Views.GraphExtensions
{
    public enum ExtendedVertexStatus
    {
        None,
        Selected,
        Root,
        Dependency,
        DeeperDependency,
        VariableSelection
    }

    public class ExtendedVertex : VertexBase
    {
        public string Text { get; set; }
        public string ToolTip { get; set; }
        public ExtendedVertexStatus Status { get; set; }
        public bool Collapsed { get; set; }

        public ExtendedVertex()
            : this("$UNSET$")
        {

        }

        public ExtendedVertex(string text)
        {
            Text = text;
        }
    }

    public class WsmVertex : ExtendedVertex
    {
        public WsmVertex() : base("WSM") { }
    }

    public class InvisibleVertex : ExtendedVertex
    {
        public InvisibleVertex(string text) : base(text) { }
    }
}
