﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using FourqlModeler.ViewModels;

namespace FourqlModeler.Views.GraphExtensions.ModuleGraph
{
    public class RootVertex : InvisibleVertex
    {
        public RootVertex() : base("Root") { }
    }

    public class FileVertex : ExtendedVertex
    {
        public ModuleViewModel ModuleViewModel { get; set; }
    }

    public class SyntaxErrorVertex : FileVertex
    {
        public ICollection<ErrorDesc> Errors { get; set; }
    }

    public class ModuleEntryVertex : FileVertex
    {
        public string Name { get; set; }
        public bool ShowDetails { get; set; }

        public ModuleEntryVertex()
        {
            ShowDetails = true;
        }
    }

    public class ErroneousVertex : ModuleEntryVertex
    {
        public ICollection<ErrorDesc> Errors { get; set; }
    }

    public class DuplicatedModuleVertex : ModuleEntryVertex
    {
    }

    public class DuplicatedModuleAggregateVertex : ExtendedVertex
    {
        public string Name { get; set; }
    }

    public class MissingModuleVertex : ExtendedVertex
    {
        public string Name { get; set; }
    }
}
