﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using FourqlParser.Structures;

namespace FourqlModeler.Views.GraphExtensions.WSMGraph
{
    public class ModuleWsmVertex : ExtendedVertex
    {
        public string ModuleName { get; set; }
        public Module Module { get; set; }
    }
    
    public class DomainsVertex : ExtendedVertex
    {
    }

    public class DomainVertex : ExtendedVertex
    {
        public string DomainName { get; set; }
        public string DomainPattern { get; set; }
        public DomainType DomainType { get; set; }
        public Domain Domain { get; set; }
    }

    public class DomainValueVertex : ExtendedVertex
    {
        public object Value { get; set; }
    }

    public class RelationsVertex : ExtendedVertex
    {
    }

    public class RelationVertex : ExtendedVertex
    {
        public string RelationName { get; set; }
        public string RelationPattern { get; set; }
        public Relation Relation { get; set; }
    }

    public class FactVertex : ExtendedVertex
    {
        public string Pattern { get; set; }
        public LogicValue Value { get; set; }
        public Fact Fact { get; set; }
    }

    public class RuleVertex : ExtendedVertex
    {
        public string ModuleName { get; set; }
        public string HeadPattern { get; set; }
        public string BodyPattern { get; set; }
        public Rule Rule { get; set; }
    }

    public class RuleFactVertex : FactVertex
    {
        public string ModuleName { get; set; }
        public Rule Rule { get; set; }
    }
}
