﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using FourqlModeler.ViewModels;
using FourQLInterpreter.WSM;

namespace FourqlModeler.Views
{
    /// <summary>
    /// Interaction logic for HistoryView.xaml
    /// </summary>
    public partial class HistoryView : UserControl
    {
        private object sender;

        private ModuleView parent;

        private bool _noChangeHidden = false;

        public HistoryView(EvaluationHistory wsmData, object sender, ModuleView moduleView)
        {
            this.sender = sender;

            this.parent = moduleView;

            InitializeComponent();


            HistoryViewModel.Module = wsmData.EvaluatedModule;
           // HistoryViewModel.History = HistoryViewModel.BuildIterations(wsmData);
            HistoryViewModel.Events = HistoryViewModel.BuildEvents(wsmData);
        }

        private void ButtonBase_OnClick(object o, RoutedEventArgs e)
        {
            parent.OpenWsmMeldRuleVertices(sender, e);
        }

        private void ShowHide_OnClick(object o, RoutedEventArgs e)
        {
            _noChangeHidden = !_noChangeHidden;
            if (_noChangeHidden)
                hide_btn.Content = "Show 'NO__CHANGE'";
            else
                hide_btn.Content = "Hide 'NO__CHANGE'";
        }
    }
}
