﻿using System;
using System.Windows;
using System.Windows.Controls;
using FourqlModeler.ViewModels;
using Xceed.Wpf.AvalonDock.Controls;
using Xceed.Wpf.AvalonDock.Layout;

namespace FourqlModeler.Views.Initialization
{
    class PanesStyleSelector : StyleSelector
    {
        public Style ModuleEditorViewStyle
        {
            get;
            set;
        }

        public Style ExtendedGraphViewStyle
        {
            get;
            set;
        }
        
        public override Style SelectStyle(object item, DependencyObject container)
        {
            if (item is ModuleEditorView)
            {
                return ModuleEditorViewStyle;
            }

            if (item is ExtendedGraphView)
            {
                return ExtendedGraphViewStyle;
            }

            return base.SelectStyle(item, container);
        }
    }
}
