﻿using System;
using System.IO;
using System.Windows.Controls;
using System.Xml;
using FourqlModeler.Controls;
using FourqlModeler.ViewModels;
using ICSharpCode.AvalonEdit.Highlighting;

namespace FourqlModeler.Views
{
    /// <summary>
    /// Interaction logic for ModuleEditor.xaml
    /// </summary>
    public partial class ModuleEditorView : UserControl
    {
        public ModuleEditorView(ModuleViewModel moduleViewModel)
        {
            InitializeComponent();
            DataContext = moduleViewModel;

            // FIXME: BIND MORE TO MODEL/VIEWMODEL - LIKE CONTENT AND SO ON.
            // FIXME: GENERATE GRAMMAR PER VERIFICATION? TO HIGHLIGHT MORE? OR MAYBE ADD MORE RULESETS AND SWITCH BETWEEN THOSE?
            // Read our syntax for modules.
            IHighlightingDefinition customHighlighting;
            using (Stream stream = typeof(App).Assembly.GetManifestResourceStream("FourqlModeler.FourqlSyntax.xshd"))
            {
                if (stream == null)
                {
                    throw new InvalidOperationException("Could not find embedded resource: FourqlModeler.FourqlSyntax.xshd");
                }

                using (XmlReader reader = new XmlTextReader(stream))
                {
                    customHighlighting = ICSharpCode.AvalonEdit.Highlighting.Xshd.
                        HighlightingLoader.Load(reader, HighlightingManager.Instance);
                    reader.Close();
                }
                stream.Close();
            }
            
            HighlightingManager.Instance.RegisterHighlighting("4QL", new string[] { ".4ql" }, customHighlighting);
            EditorBox.SyntaxHighlighting = HighlightingManager.Instance.GetDefinition("4QL");
            EditorBox.ModuleViewModel = moduleViewModel;
        }
    }
}
