﻿using GraphX;
using GraphX.GraphSharp.Algorithms.OverlapRemoval;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlModeler
{
    class OverlapRemovalProvider
    {
        public IOverlapRemovalParameters CreateParameters(OverlapRemovalAlgorithmTypeEnum algorithmType, double verticalGap, double horizontalGap)
        {
            return CreateParametersFloat(algorithmType, (float)verticalGap, (float)horizontalGap);
        }

        private IOverlapRemovalParameters CreateParametersFloat(OverlapRemovalAlgorithmTypeEnum algorithmType, float verticalGap, float horizontalGap)
        {
            switch (algorithmType)
            {
                case OverlapRemovalAlgorithmTypeEnum.FSA:
                    return new OverlapRemovalParameters() { VerticalGap = verticalGap, HorizontalGap = horizontalGap };
                case OverlapRemovalAlgorithmTypeEnum.OneWayFSA:
                    return new OneWayFSAParameters() { VerticalGap = verticalGap, HorizontalGap = horizontalGap };
                default:
                    return null;
            }
        }
    }
}
