﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using FourqlModeler.ViewModels;

namespace FourqlModeler.Views.ValueConverters
{
    public class ErrorGroupNameConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var group = value as CollectionViewGroup;
            if (group != null)
            {
                if (group.ItemCount > 0)
                {
                    var error = group.Items[0] as ErrorDesc;
                    if (error != null)
                    {
                        return String.Format("#{0}. {1}", error.GroupId, error.Description);
                    }
                }
            }
            return group.Name;
        }
        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
