﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using System.Windows.Media;
using FourQLInterpreter.Reasoning;

namespace FourqlModeler.Views.ValueConverters
{
    [ValueConversion(typeof(FactResult), typeof(SolidColorBrush))]
    class FactResultColorConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value.Equals(FactResult.FACT_ADDED))
                return new SolidColorBrush(Colors.Green);

            if (value.Equals(FactResult.FACT_CHANGED))
                return new SolidColorBrush (Colors.DarkGreen);
            return new SolidColorBrush(Colors.Gray);
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
