﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using FourQLInterpreter.Reasoning;

namespace FourqlModeler.Views.ValueConverters
{
    class FactResultTooltipConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var res = (FactResult) value;
            switch (res)
            {
                    case FactResult.FACT_ADDED:
                    return "New fact added to the model.";
                    case FactResult.NO_CHANGE:
                    return "Fact already existed in the model.";
                    case FactResult.FACT_CHANGED:
                    return "Negation of the fact already existed in the model";
            }
            return "";
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
