﻿using FourqlModeler.ViewModels;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Windows.Data;

namespace FourqlModeler.Views.ValueConverters
{
    public class ModuleModelsNoErrorValueConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null)
            {
                return true;
            }
            return value is IEnumerable ? Convert((IEnumerable)value) : value.Equals(0);
        }

        public bool Convert(IEnumerable values)
        {
            foreach (var value in values)
            {
                if (value is IEnumerable)
                {
                    if (!Convert((IEnumerable)value))
                    {
                        return false;
                    }
                }
                else if (value is CollectionViewGroup)
                {
                    if (!Convert(((CollectionViewGroup)value).Items))
                    {
                        return false;
                    }
                }
                else if (value is ModuleViewModel && ((ModuleViewModel)value).SyntaxErrors.Count > 0)
                {
                    return false;
                }
            }
            return true;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new Exception("ConvertBack not supported for ModuleModelsNoErrorValueConverter");
        }

        #endregion
    }
}
