﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace FourqlModeler.Views.ValueConverters
{
    class PhaseTooltipConverter : IValueConverter
    {

        private const string GenerateTooltip = "In this phase facts are generated from rules with true premises.";

        private const string CorrectionTooltip = "This is the phase of inconsistency propagation. \n" +
                                                 "Inconsistent facts (positive and negative) are generated from rules with inconsistent premises.";

        private const string RetractTooltip = "In this phase conclusions based on defeated premises are retracted. \n" +
                                              "Only inconsistent facts are left.";

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var phaseName = value as string;
            switch (phaseName)
            {
                case "Generate":
                    return GenerateTooltip;
                case "FindCorrection":
                    return CorrectionTooltip;
                case "Retract":
                    return RetractTooltip;
                default:
                    return "";
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
