﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.ExpParser.Converters
{
    class LogicValueConverter : ExprParserBaseVisitor<LogicValue>
    {
        public override LogicValue VisitValueLogic(ExprParser.ValueLogicContext context)
        {
            return context.LogicValue.Accept(this);
        }

        public override LogicValue VisitValueTrue(ExprParser.ValueTrueContext context)
        {
            return LogicValue.TRUE;
        }

        public override LogicValue VisitValueFalse(ExprParser.ValueFalseContext context)
        {
            return LogicValue.FALSE;
        }

        public override LogicValue VisitValueInconsistent(ExprParser.ValueInconsistentContext context)
        {
            return LogicValue.INCONSISTENT;
        }

        public override LogicValue VisitValueUnknown(ExprParser.ValueUnknownContext context)
        {
            return LogicValue.UNKNOWN;
        }
    }
}
