﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.ModParser.Converters
{
    class FactConverter : ModuleParserBaseVisitor<Fact>
    {
        public Fact Fact { get; private set; }

        public override Fact VisitFact(ModuleParser.FactContext context)
        {
            Fact = new Fact() { IsNegative = context.IsNegative != null, RelationName = context.RelationName.Text, ParserContext = context };
            context.FactArgs.Accept(this);
            return Fact;
        }

        public override Fact VisitFactArguments(ModuleParser.FactArgumentsContext context)
        {
            Fact.Values.Add(context.Head.Accept(new ValueConverter()));
            return context.Tail != null ? context.Tail.Accept(this) : null;
        }

        public override Fact VisitNoFactArguments(ModuleParser.NoFactArgumentsContext context)
        {
            return null;
        }
    }
}
