﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.ModParser.Converters
{
    class LiteralConverter : ModuleParserBaseVisitor<Literal>
    {
        public Literal Literal { get; set; }

        public override Literal VisitLiteral(ModuleParser.LiteralContext context)
        {
            Literal = new Literal() { RelationName = context.RelationName.Text, ParserContext = context };
            context.LiteralArgs.Accept(this);
            return Literal;
        }

        public override Literal VisitLiteralArguments(ModuleParser.LiteralArgumentsContext context)
        {
            context.Head.Accept(this);
            return context.Tail != null ? context.Tail.Accept(this) : null;
        }

        public override Literal VisitNoLiteralArguments(ModuleParser.NoLiteralArgumentsContext context)
        {
            return null;
        }

        public override Literal VisitLiteralVariableArgument(ModuleParser.LiteralVariableArgumentContext context)
        {
            Literal.Values.Add(new ValueHolder(context.VariableName.Text, DomainType.VARIABLE));
            return null;
        }

        public override Literal VisitLiteralValueArgument(ModuleParser.LiteralValueArgumentContext context)
        {
            Literal.Values.Add(context.Value.Accept(new ValueConverter()));
            return null;
        }
    }
}
