﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.ModParser.Converters
{
    class ModuleConverter : ModuleParserBaseVisitor<Module>
    {
        public Module Module { get; private set; }

        public override Module VisitModule(ModuleParser.ModuleContext context)
        {
            Module = new Module() { Name = context.ModuleName.Text, ParserContext = context };
            // FIXME: Should walk through known selected nodes.
            VisitChildren(context);
            return Module;
        }

        public override Module VisitNoDomains(ModuleParser.NoDomainsContext context)
        {
            return null;
        }

        public override Module VisitDomain(ModuleParser.DomainContext context)
        {
            var domain = context.Accept(new DomainConverter());
            Module.Domains.Add(domain);
            return null;
        }

        public override Module VisitRelation(ModuleParser.RelationContext context)
        {
            var relation = context.Accept(new RelationConverter());
            Module.Relations.Add(relation);
            return null;
        }

        public override Module VisitRuleDef(ModuleParser.RuleDefContext context)
        {
            var rule = context.Accept(new RuleConverter());
            Module.Rules.Add(rule);
            return null;
        }

        public override Module VisitFact(ModuleParser.FactContext context)
        {
            Module.Facts.Add(context.Accept(new FactConverter()));
            return null;
        }
    }
}
