﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.ModParser.Converters
{
    class RelationConverter : ModuleParserBaseVisitor<Relation>
    {
        public Relation Relation { get; private set; }

        public override Relation VisitRelation(ModuleParser.RelationContext context)
        {
            Relation = new Relation() { Name = context.RelationName.Text, ParserContext = context };
            context.RelationArgs.Accept(this);
            return Relation;
        }

        public override Relation VisitRelationArguments(ModuleParser.RelationArgumentsContext context)
        {
            context.Head.Accept(this);
            return context.Tail != null ? context.Tail.Accept(this) : null;
        }

        public override Relation VisitNoRelationArguments(ModuleParser.NoRelationArgumentsContext context)
        {
 	         return null;
        }

        public override Relation VisitRelationDomainArg(ModuleParser.RelationDomainArgContext context)
        {
            Relation.DefinedDomains[Relation.paramCount()] = context.DomainName.Text;
            return null;
        }

        public override Relation VisitRelationTypeArg(ModuleParser.RelationTypeArgContext context)
        {
            Relation.PrimitiveDomains[Relation.paramCount()] = context.Type.Accept(new TypeConverter());
            return null;
        }
    }
}
