﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.ModParser.Converters
{
    class TypeConverter : ModuleParserBaseVisitor<DomainType>
    {
        public override DomainType VisitTypeLiteral(ModuleParser.TypeLiteralContext context)
        {
            return DomainType.LITERAL;
        }

        public override DomainType VisitTypeLogic(ModuleParser.TypeLogicContext context)
        {
            return DomainType.LOGIC;
        }

        public override DomainType VisitTypeString(ModuleParser.TypeStringContext context)
        {
            return DomainType.STRING;
        }

        public override DomainType VisitTypeInteger(ModuleParser.TypeIntegerContext context)
        {
            return DomainType.INTEGER;
        }

        public override DomainType VisitTypeReal(ModuleParser.TypeRealContext context)
        {
            return DomainType.REAL;
        }

        public override DomainType VisitTypeDateTime(ModuleParser.TypeDateTimeContext context)
        {
            return DomainType.DATE_TIME;
        }

        public override DomainType VisitTypeDate(ModuleParser.TypeDateContext context)
        {
            return DomainType.DATE;
        }
    }
}
