﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using FourqlParser.StaticAnalysis;

namespace FourqlParser.Structures
{
    public class Module : OutputSource
    {
        public String Name { get; set; }
        public bool IsInternalExternal { get; set; }
        public ICollection<Domain> Domains { get; set; }
        public ICollection<Relation> Relations { get; set; }
        public ICollection<Rule> Rules { get; set; }
        public ICollection<Fact> Facts { get; set; }
        public ModuleInvalidDefinitions InvalidDefinitions { get; set; }

        public Module()
        {
            Domains = new List<Domain>();
            Relations = new List<Relation>();
            Rules = new List<Rule>();
            Facts = new List<Fact>();
            InvalidDefinitions = new ModuleInvalidDefinitions();
        }

        public Domain FindDomain(string domainName)
        {
            foreach (var domain in Domains)
            {
                if (domain.Name.Equals(domainName))
                {
                    return domain;
                }
            }
            return null;
        }

        public Relation FindRelation(string relationName)
        {
            foreach (var relation in Relations)
            {
                if (relation.Name.Equals(relationName))
                {
                    return relation;
                }
            }
            return null;
        }

        public ICollection<Rule> FindRules(string relationName)
        {
            var rules = new List<Rule>();
            foreach (var rule in Rules)
            {
                if (rule.Head.RelationName.Equals(relationName))
                {
                    rules.Add(rule);
                }
            }
            return rules;
        }
    }
}
