﻿using Antlr4.Runtime;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Structures
{
    public interface IOutputSource
    {
        int startLine();
        int endLine();
        int startColumn();
        int endColumn();
    }

    public class OutputSource : IOutputSource
    {
        public ParserRuleContext ParserContext { get; set; }

        public int startLine()
        {
            return ParserContext != null ? ParserContext.Start.Line : -1;
        }

        public int endLine()
        {
            return ParserContext != null ? ParserContext.Stop.Line : -1;
        }

        public int startColumn()
        {
            return ParserContext != null ? ParserContext.Start.Column : -1;
        }

        public int endColumn()
        {
            return ParserContext != null ? ParserContext.Stop.Column : -1;
        }
    }
}
