﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Structures.Print
{
    public class ValuePrinter
    {
        public static String ToValueString(ValueHolder value)
        {
            return ToValueString(value.Value, value.Type);
        }

        public static String ToValueString(object value, DomainType type)
        {
            switch (type)
            {
                case DomainType.STRING:
                    return String.Format("\"{0}\"", value);
                case DomainType.LOGIC:
                    return value.ToString().ToLower();
                case DomainType.REAL:
                    var strReal = value.ToString();
                    return strReal.Contains('.') ? strReal : strReal + ".0";
                case DomainType.DATE:
                    return ((DateTime)value).ToString("dd-MM-yyyy");
                case DomainType.DATE_TIME:
                    return ((DateTime)value).ToString("dd-MM-yyyy HH:mm");
                default:
                    return value.ToString();
            }
        }
    }
}
