﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.Converters
{
    class DomainConverter : ModuleParserBaseVisitor<Domain>
    {
        public override Domain VisitDomain(ModuleParser.DomainContext context)
        {
            return new Domain()
            {
                Name = context.DomainName.Text, 
                Type = context.Type.Accept<DomainType>(new TypeConverter()), 
                ParserContext = context, 
                Imports = context.domainImports() == null ? new List<Tuple<string, string>>() : context.domainImports().Accept(new ImportConverter())
            };
        }
    }

    class ImportConverter : ModuleParserBaseVisitor<ICollection<Tuple<string, string>>>
    {
        public override ICollection<Tuple<string, string>> VisitDomainImports(ModuleParser.DomainImportsContext context)
        {
            var result = new HashSet<Tuple<string, string>>();
            foreach (var domain in context.domainName())
            {
                result.Add(new Tuple<string, string>(domain.ModuleName.Text, domain.DomainName.Text));
            }
            return result;
        }
    }
}
