﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.Converters
{
    class LogicValueConverter : ModuleParserBaseVisitor<LogicValue>
    {
        public override LogicValue VisitValueLogic(ModuleParser.ValueLogicContext context)
        {
            return context.LogicValue.Accept(this);
        }

        public override LogicValue VisitValueTrue(ModuleParser.ValueTrueContext context)
        {
            return LogicValue.TRUE;
        }

        public override LogicValue VisitValueFalse(ModuleParser.ValueFalseContext context)
        {
            return LogicValue.FALSE;
        }

        public override LogicValue VisitValueInconsistent(ModuleParser.ValueInconsistentContext context)
        {
            return LogicValue.INCONSISTENT;
        }

        public override LogicValue VisitValueUnknown(ModuleParser.ValueUnknownContext context)
        {
            return LogicValue.UNKNOWN;
        }
    }
}
