﻿using FourqlParser.Structures;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Parsers.Converters
{
    class RuleHeadConverter: ModuleParserBaseVisitor<Fact>
    {
        public Fact Fact { get; private set; }

        public override Fact VisitRuleHead(ModuleParser.RuleHeadContext context)
        {
            var literal = context.Literal.Accept(new LiteralConverter());
            Fact = new Fact() { IsNegative = context.IsNegative != null, RelationName = literal.RelationName, Values = literal.Values, ParserContext = context };
            return Fact;
        }
    }
}
