﻿using Antlr4.Runtime;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Structures
{
    public abstract class Contextable
    {
        public IToken Token { get; private set; }

        public Contextable(IToken token) {
            Token = token;
        }

        public bool hasContext() {
            return Token != null;
        }
    }

    public class HiddenData : Contextable
    {
        public Boolean IsWhiteSign { get { return !IsComment; } }

        public Boolean IsComment { get; private set; }

        public HiddenData(IToken token, bool isComment) : base(token)
        {
            IsComment = isComment;
        }
    }
}
