﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Structures
{
    public enum DomainType
    {
        VARIABLE,
        LITERAL,
        LOGIC,
        STRING,
        INTEGER,
        REAL,
        DATE,
        DATE_TIME
    }

    public class DomainTypeUtils {
        private DomainTypeUtils() { }

        public static String getName(DomainType type) {
            return type.ToString().ToLower();
        }

        public static DomainType getType(String typeName)
        {
            typeName = typeName.ToUpper();
            foreach (var type in Enum.GetValues(typeof(DomainType)).Cast<DomainType>())
            {
                if (type.ToString().Equals(typeName))
                {
                    return type;
                }
            }
            return DomainType.VARIABLE;
        }
    }

    public class Domain : OutputSource
    {
        public String Name { get; set; }
        public DomainType Type { get; set; }
        public ICollection<Tuple<string, string>> Imports { get; set; }

        public Domain()
        {
            Imports = new List<Tuple<string, string>>();
        }
    }
}
