﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using FourqlParser.Structures.Print;

namespace FourqlParser.Structures
{
    public class Fact : Literal
    {
        public LogicValue Value { get; set; }
        public Boolean IsNegative { get { return Value == LogicValue.FALSE; } set { Value = value ? LogicValue.FALSE : LogicValue.TRUE; } }

        public Fact()
        {
            Value = LogicValue.TRUE;
        }

        public Literal CreateLiteralOfFact()
        {
            var literal = new Literal() { RelationName = RelationName, ParserContext = ParserContext };
            foreach (var value in Values)
            {
                literal.Values.Add(value);
            }
            return literal;
        }

        public override bool Equals(object obj)
        {
            var that = obj as Fact;
            if (that == null)
            {
                return false;
            }

            return this.IsNegative.Equals(that.IsNegative) && SignatureEquals(obj);
        }

        public bool SignatureEquals(object obj)
        {
            return base.Equals(obj);
        }

        public override string ToString()
        {
            return (IsNegative ? "not " : "") + new ExprPrinter("", false).ConvertExpr(this).ToString();
        }
    }
}
