﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FourqlParser.Structures.Print
{
    public class Printer
    {
        protected Boolean PrintNewLines;
        public StringBuilder Builder;

        public Printer(Boolean printNewLines = true)
        {
            PrintNewLines = printNewLines;
            Builder = new StringBuilder();
        }

        protected virtual Printer Append(String str)
        {
            Builder.Append(str);
            return this;
        }

        protected virtual Printer AppendLine(String str = "")
        {
            if (PrintNewLines)
            {
                Builder.AppendLine(str);
            }
            else
            {
                Builder.Append(" ");
                Builder.Append(str);
            }
            return this;
        }

        protected virtual Printer AppendNewLineNoSpace(String str, Boolean appendWithNewLine)
        {
            if (appendWithNewLine)
            {
                Builder.AppendLine(str);
            }
            else
            {
                Builder.Append(str);
            }
            return this;
        }
    }
}
